<template>
  <div class="registration-form">
    <ob-form
      :ref="formRefName"
      :form-model="formModel"
      :form-data="formData"
      :is-only-submit="true"
      :is-show-controls="isShowControls"
      :is-show-required="false"
      ok-text="Зарегистрироваться"
      @submit="onSubmit"
    >
      <div class="registration-form__title">
        Укажите, пожалуйста, ваши контактные данные
      </div>
      <ob-input
        ref="email"
        id="registration-email"
        v-model="formData.email"
        class="bottom-20"
        label="Электронная почта"
        placeholder="Будет использоваться для входа"
        :is-valid="validStateEmail"
        property="email"
        @blur="checkEmail"
        @on-enter="checkEmail"
      />
      <transition
        name="toggle-height"
        mode="out-in"
      >
        <div
          v-if="emailState && emailState.isPreregisteredParticipantExist"
          class="bottom-20"
        >
          <p class="text-style">
            <template v-if="!confirmLinkIsSent">
              Этот адрес электронной почты уже зарегистрирован в системе, но ещё не подтверждён.
              <span
                class="link-style"
                @click="regReplay"
              >Отправить повторно письмо</span> для подтверждения и входа с временным паролем?
            </template>

            <template v-else>
              Письмо со ссылкой и временным паролем отправлено, проверьте вашу почту.
              <br>
              <span class="-gray-slate">
                Отправить повторно:
                <ObCountdown
                  ref="regReplayCountdown"
                  duration="30"
                  :key="confirmLinkKey"
                >
                  <template slot="finished">
                    <a
                      class="link-style"
                      @click="regReplay"
                    >
                      повторить отправку письма
                    </a>
                  </template>
                </ObCountdown>
              </span>
            </template>
          </p>
        </div>
        <div
          v-else-if="emailState && emailState.isParticipantExist"
          class="bottom-20"
        >
          <p class="text-style">
            Этот адрес электронной почты уже зарегистрирован на платформе.
            <router-link
              tag="a"
              class="link-style"
              :to="{ name: 'login' }"
            >
              Хотите авторизоваться с этим адресом
            </router-link>?
          </p>
        </div>
      </transition>
      <div
        id="registration-phone"
        :class="[ 'row-block', { 'alternative': !isConfirmedPhone && !isBlockPhone }]"
      >
        <div class="col-block">
          <ob-input
            ref="phone"
            v-model="formData.phone"
            label="Номер моб. телефона"
            :mask="phoneMask"
            :is-masked="true"
            :disabled="!validStateEmail"
            :is-valid="validStatePhone"
            label-info="Необходим для подтверждения вашей учётной записи"
            property="phone"
            popper-class="registration-tooltip"
            @on-enter="sendSms"
          />
        </div>
        <div class="col-block">
          <transition
            name="fadeIn"
            mode="out-in"
          >
            <ob-tooltip
              v-if="!isConfirmedPhone && !isBlockPhone"
              v-model="showTooltip"
              :disabled="isDisabledSmsButtonTooltip"
            >
              <div slot="content">
                Отправить повторную SMS с пин-кодом возможно через: {{ smsTime }} с
              </div>
              <div>
                <transition name="fadeIn">
                  <ob-button
                    label="Получить SMS"
                    type="outline"
                    :disabled="isDisabledSmsButton"
                    @click="sendSms"
                  />
                </transition>
              </div>
            </ob-tooltip>
            <div
              v-else-if="isConfirmedPhone"
              class="registration-form__text-success"
            >
              Номер моб. телефона подтверждён
            </div>
            <div
              v-else-if="isBlockPhone"
              class="registration-form__text-error"
            >
              Номер телефона не подтверждён
            </div>
          </transition>
        </div>
      </div>
      <transition name="toggle-height">
        <div
          v-if="isDisabledSmsButton && isPhoneSmsError && !viewInputCode"
          class="registration-form__sms-timeout"
        >
          Отправить повторную SMS с пин-кодом возможно через: {{ smsTime }} с
        </div>
      </transition>
      <transition name="toggle-height">
        <ob-alert
          v-if="isPhoneSmsError"
          theme="warning"
          icon="alert"
          class="registration-form__sms-alert"
          :hide-close-button="true"
        >
          Для продолжения необходимо ввести новый пин-код.
          <template v-if="viewInputCode">
            Мы отправили его на указанный номер.
            <br><br>
            Введите, пожалуйста, новый пин-код.
          </template>
          <template v-else>
            Получите и введите, пожалуйста, новый пин-код.
          </template>
        </ob-alert>
      </transition>
      <transition name="toggle-height">
        <sms-code-form
          v-if="viewInputCode"
          ref="sms-code-form"
          @confirm="onConfirmPhone"
          @confirm-error="onBlockPhone"
        />
        <div
          v-if="isBlockPhone && isBlockPhoneSms"
          class="registration-form__text-error --is-row"
        >
          <p class="mb20 mt20">
            Слишком много попыток регистрации. В целях безопасности возможность регистрации для вас приостановлена на некоторое время.
          </p>
          <p class="mb30">
            Осталось <ObCountdown :duration="smsTime" />
          </p>
          <ob-button
            label="Понятно"
            @click="inputNewPhone"
          />
        </div>
        <div
          v-else-if="isBlockPhone"
          class="registration-form__text-error --is-row"
        >
          <p class="mb20 mt20">
            Слишком много неудачных попыток ввода пин-кода. В целях безопасности возможность регистрации для вас остановлена на 1 час.
          </p>
          <ob-button
            label="Понятно"
            @click="inputNewPhone"
          />
        </div>
      </transition>
      <transition name="toggle-height">
        <div v-if="!isBlockPhone">
          <div class="registration-form__title top-40">
            Данные о вашей организации
          </div>
          <ob-select
            v-model="formData.countrySymbolCode"
            value-exp="countryCode"
            display-exp="titleWording"
            property="countryCode"
            label="Страна регистрации"
            label-info="Запрашиваемые данные будут зависеть от страны регистрации"
            placeholder="Выберите страну"
            :items="countries"
            :is-standart="true"
            :disabled="!isConfirmedPhone"
            :is-search="true"
            :is-auto-complete="false"
            popper-class="registration-tooltip"
            class="bottom-20"
            @input="onCountryChange"
          />

          <transition
            name="fadeIn"
            mode="out-in"
          >
            <ob-input
              v-if="isShowLegalNameShortField"
              v-model="formData.legalNameShort"
              :disabled="isInnDisabled"
              :is-valid="!!formData.legalNameShort"
              property="legalNameShort"
              label="Наименование организации"
              placeholder="Укажите наименование"
              class="bottom-20"
            />
          </transition>

          <InnField
            ref="inn"
            id="registration-inn"
            :disabled="isInnDisabled"
            :hostname="currentHostname"
            :phone-check-uuid="phoneCheckUuid"
            :country-code="formData.countrySymbolCode || ''"
            :errors-map="regErrorKeyMap"
            @reset-phone-sms="clearPhoneSmsState"
            @change="onInnChanged"
          />

          <transition
            name="fadeIn"
            mode="out-in"
          >
            <div
              v-if="isShowKppField"
              class="row-block bottom-20"
            >
              <div class="col-block">
                <ObInput
                  v-model="formData.card.kpp"
                  :is-dirty-force="true"
                  :is-valid="validStateKpp"
                  property="card.kpp"
                  label="КПП"
                  placeholder="Введите КПП"
                  type="number:strict"
                  @input="resetKppState"
                />
              </div>

              <div class="col-block">
                <template v-if="formData.card.kpp.length === 9">
                  <ObButton
                    v-if="isKppExist === null"
                    label="Проверить"
                    @click="checkKpp"
                  />

                  <div
                    v-else-if="isKppExist"
                    class="text-error"
                  >
                    Такой КПП уже зарегистрирован, укажите другой
                  </div>

                  <div
                    v-else
                    class="text-success"
                  >
                    КПП принят
                  </div>
                </template>
              </div>
            </div>
          </transition>

          <card-info
            ref="cardInfo"
            id="registration-card"
            :card="formData.card"
            :inn="formData.inn"
            @on-clear="onCloseCardInfo"
          />

          <transition name="toggle-height">
            <div
              v-if="isShowAcceptTerms"
              class="registration-form__block-accept"
            >
              <ob-checkbox
                v-model="formData.isAcceptTerms"
              >
                <div
                  slot="label"
                  class="registration-form__block-accept-text"
                >
                  Я принимаю условия
                  <a
                    :href="`./static/${currentHostname}_termsofuse.pdf?h=${uuid.v4()}`"
                    target="_blank"
                    class="inline-link"
                  >Пользовательского соглашения</a> и даю своё согласие на обработку моей персональной
                  информации на условиях, определенных
                  <a
                    :href="`./static/${currentHostname}_privacypolicy.pdf?h=${uuid.v4()}`"
                    target="_blank"
                    class="inline-link"
                  >Политикой конфиденциальности</a>.
                </div>
              </ob-checkbox>
            </div>
          </transition>
        </div>
      </transition>
    </ob-form>

    <Tour :steps="steps" />
  </div>
</template>

<script>
  import { uuid } from 'vue-uuid'
  import { getCookie } from '@/utils/cookie'
  import ObInput from 'common-components/src/obComponents/obInput'
  import ObForm from 'common-components/src/obComponents/obForm'
  import ObSelect from 'common-components/src/obComponents/obSelect'
  import ObButton from 'common-components/src/obComponents/obButton/index'
  import ObCheckbox from 'common-components/src/obComponents/obCheckbox/index'
  import ObTooltip from 'common-components/src/obComponents/obTooltip/index'
  import ObCountdown from 'common-components/src/obComponents/obCountdown'
  import ObAlert from 'common-components/src/obComponents/obAlert'

  import model from './model'
  import SmsCodeForm from './smsCodeForm'
  import CardInfo from './cardInfo'
  import InnField from './innField'
  import Tour from '../../components/Tour'

  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
  import api from '@/api'
  import { mapActions } from 'vuex'

  let checked = {
    email: null,
    phone: null,
    inn: null
  }

  export default {
    name: 'RegistrationFirstStep',
    components: {
      ObTooltip,
      ObCheckbox,
      CardInfo,
      SmsCodeForm,
      InnField,
      ObButton,
      ObSelect,
      ObForm,
      ObInput,
      ObCountdown,
      ObAlert,
      Tour
    },
    mixins: [
      FormValidationMixin
    ],
    data () {
      return {
        uuid,
        api,
        countries: [],
        smsTime: 180,
        smsInterval: null,
        phoneMask: '+7 (999) 999-99-99',
        formModel: model,
        viewInputCode: false,
        isConfirmedPhone: false,
        isPhoneSmsError: false,
        emailState: null,
        confirmLinkIsSent: false,
        confirmLinkKey: 0,
        phoneCheckUuid: null,
        checked: { ...checked },
        showTooltip: false,
        isBlockPhone: false,
        isBlockPhoneSms: false,
        isInnValid: null,
        preCheckedPhone: null,
        publicPath: process.env.BASE_URL,
        isKppExist: null,
        regErrorKeyMap: {
          10000: 'isParticipantExist',
          10001: 'isPreregisteredParticipantExist'
        }
      }
    },
    computed: {
      currentHostname () {
        return window.location.host.split('gruzi').length > 1 ? 'gruziru': 'oboz'
      },
      validStateEmail () {
        if (!this.emailState || this.$refs.email.mainError) return null
        return this.emailState && !this.emailState.isPreregisteredParticipantExist && !this.emailState.isParticipantExist
      },
      validStatePhone () {
        if (!this.isBlockPhone && !this.isConfirmedPhone) return null
        return !this.isBlockPhone && this.isConfirmedPhone
      },
      formIsChanged () {
        return Boolean(this.formData.email)
      },
      isDisabledSmsButton () {
        return (!this.formData.phone || (this.$refs.phone && !this.$refs.phone.isValidMask)) || this.smsInterval !== null
      },
      isDisabledSmsButtonTooltip () {
        return this.smsInterval === null || !this.preCheckedPhone
      },
      isInnDisabled () {
        return !this.isConfirmedPhone
      },
      isShowAcceptTerms () {
        return this.checked.inn
      },
      isShowControls () {
        return !this.isBlockPhone && this.isInnValid !== false
      },
      isShowLegalNameShortField () {
        if (!this.formData.countrySymbolCode || !this.formData.card) {
          return false
        }

        return this.formData.countrySymbolCode !== 'rus' || (Boolean(Object.keys(this.formData.card).length) && !this.formData.card.name)
      },
      isShowKppField () {
        return typeof this.formData.card?.kpp === 'string'
      },
      validStateKpp () {
        switch (true) {
          case this.isKppExist:
            return false

          case this.isKppExist === false:
            return true

          default:
            return null
        }
      },
      steps () {
        if (this.isShowAcceptTerms) {
          return [
            {
              target: '#registration-card',
              header: { title: 'Данные по ИНН' },
              content: 'Проверьте полученные данные о вашей организации (или ИП) во избежание ошибок.',
              params: { placement: 'right', highlight: true }
            }
          ]
        }

        return [
          {
            target: '#registration-email',
            header: { title: 'Электронная почта' },
            content: '<p>Используйте только нижний регистр — маленькие латинские буквы.</p>' +
                     '<p>Адрес электронной почты должен быть актуальным. На него мы отправим ' +
                     'проверочное письмо со ссылкой, на которую вам надо будет кликнуть.</p>',
            params: { placement: 'right', highlight: true }
          },
          {
            target: '#registration-phone',
            header: { title: 'Телефон' },
            content: '<p>Вводите только актуальный  номер телефона.</p>' +
                     '<p>СМС-сообщение с ПИН-кодом для подтверждения вы получите на него.</p>',
            params: { placement: 'right', highlight: true }
          },
          {
            target: '#registration-inn',
            header: { title: 'ИНН' },
            content: 'ИНН нужен для автоматического заполнения данных и сокращения времени проверки организации.',
            params: { placement: 'right', highlight: true }
          }
        ]
      }
    },
    watch: {
      formIsChanged (val) {
        this.$emit('form-changed', val)
      },
      'formData.inn' (val) {
        if ((this.checked.inn && val !== this.checked.inn) || !this.checked.inn) {
          this.clearInnState(false)
        }
      },
      'formData.phone' () {
        if (this.isBlockPhone) {
          this.isBlockPhone = false
        }
        if (this.isPhoneSmsError) {
          this.isPhoneSmsError = false
        }
        if (this.checked.phone || this.preCheckedPhone) {
          this.clearPhoneState(false)
          this.clearInnState()
        }
      },
      'formData.email' (val) {
        if ((val && this.checked.email && val !== this.checked.email) || !this.checked.email) {
          this.clearEmailState(false)
          this.clearPhoneState()
          this.clearInnState()
        }
      }
    },
    mounted () {
      api.registration.register.getCountriesDropdown().then((countries) => {
        this.countries = countries
      })

      this.$nextTick(() => {
        this.formData.phone = this.phoneMask.substr(0, 4)
      })
    },
    methods: {
      ...mapActions({
        setEmail: 'entry/setEmail'
      }),
      async sendSms () {
        if (!this.$refs.phone.isValidMask) return

        let phone = this.formData.phone.replace(/[()\-\s]/g, '')
        phone = phone.replace('+7', '8')
        this.$refs['sms-code-form'] && this.$refs['sms-code-form'].clearState()
        clearInterval(this.smsInterval)
        this.smsInterval = null
        this.isBlockPhone = false

        try {
          await api.registration.register.checkPhone({ phone })
          this.viewInputCode = true
          this.$refs['sms-code-form'] && this.$refs['sms-code-form'].focusInputCode()

          this.startSmsDelay()
        } catch ({ error, details }) {
          this.startSmsDelay({ delay: details })

          if (error === 10410) {
            this.isBlockPhoneSms = true

            this.onBlockPhone()
          }

          if (error === 10510) {
            this.showTooltip = true
          }
        }
        this.preCheckedPhone = phone
      },
      startSmsDelay ({ delay = 180 } = {}) {
        if (this.smsInterval) return
        this.smsTime = delay
        this.smsInterval = setInterval(() => {
          this.smsTime--
          if (this.smsTime === 0) {
            clearInterval(this.smsInterval)
            this.smsInterval = null
          }
        }, 1000)
      },
      onConfirmPhone ({ uuid }) {
        this.viewInputCode = false
        this.isConfirmedPhone = true
        this.isPhoneSmsError = false
        this.checked.phone = this.preCheckedPhone
        this.phoneCheckUuid = uuid
        clearInterval(this.smsInterval)
        this.smsInterval = null
      },
      async onInnChanged ({ isInnValid = null, card = {}, inn = null, isKppCheckNeed = false } = {}) {
        this.formData.card = card

        this.checked.inn = inn
        this.formData.inn = inn

        await this.$nextTick()

        this.isInnValid = isInnValid

        if (isKppCheckNeed) {
          await this.checkKpp()
        }

        if (Object.keys(card).length) {
          setTimeout(() => {
            this.$tours.tour.start()
          }, 300)
        }
      },
      async checkKpp () {
        const { isKppExist } = await api.registration.register.checkKpp(this.formData.inn, this.formData.card.kpp)

        this.isKppExist = isKppExist
      },
      async onSubmit () {
        this.formData.uuid = this.phoneCheckUuid
        const draftOrderId = getCookie('anon_order_draft_uuid')

        const data = {
          inn: this.checked.inn,
          email: this.checked.email,
          phone: this.checked.phone,
          uuid: this.phoneCheckUuid,
          countrySymbolCode: this.formData.countrySymbolCode,
          ...(draftOrderId ? { draftOrderId: draftOrderId } : {}),
          ...(this.formData.legalNameShort ? { legalNameShort: this.formData.legalNameShort } : {}),
          ...(this.formData.card.kpp ? { kpp: this.formData.card.kpp } : {})
        }

        try {
          await api.registration.register.submitRegistration({ data })

          // Saving email to the store to using it on the second step
          this.setEmail(data.email)

          this.$emit('changeStep', 1) // Go to the second step
        } catch (error) {
          if (error && error.code && this.regErrorKeyMap[error.code]) {
            this.$refs.inn.onError(error)

            this.formData.card = {}
          } else {
            alert(error.code + '' + error.message)
          }
        }
      },
      async checkEmail () {
        if (!this.formData.email) {
          return
        }

        this.$nextTick(async () => {
          if (!this.$refs.email.mainError && this.formData.email !== this.checked.email) {
            this.clearPhoneState()
            this.clearInnState()
            this.validator.$reset()
            let result = {}

            try {
              this.$refs.email.dirty = true
              let email = this.formData.email
              let res = await api.registration.register.checkEmail({ email })
              result = { ...res }
              this.checked.email = this.formData.email
              setTimeout(() => {
                this.validStateEmail && this.$refs.phone.focus()
              }, 100)
            } catch (e) {
              result = null
            }

            this.emailState = result
          }
        })
      },
      getIconByValidateState (state) {
        switch (state) {
          case null:
            return ''
          case true:
            return 'checked'
          case false:
            return 'alert'
        }
      },
      clearPhoneState (clearValue = true) {
        this.viewInputCode = false
        this.isConfirmedPhone = false
        this.checked.phone = null
        this.phoneCheckUuid = null
        this.isBlockPhone = false
        this.isBlockPhoneSms = false
        this.preCheckedPhone = null
        clearInterval(this.smsInterval)
        this.smsInterval = null
        if (clearValue) {
          this.formData.phone = this.phoneMask.substr(0, 4)
        }
      },
      clearPhoneSmsState () {
        this.isPhoneSmsError = true
        this.clearPhoneState(false)
        this.sendSms()
      },
      clearEmailState (clearValue = true) {
        this.checked.email = null
        this.emailState = null
        if (clearValue) {
          this.formData.email = null
        }
      },
      clearInnState (clearValue = true) {
        this.checked.inn = null
        this.isInnValid = null
        this.formData.card = {}

        if (clearValue) {
          this.$refs.inn.clear()
        }

        this.formData.isAcceptTerms = false
        this.formData.firstName = ''
        this.formData.lastName = ''
        this.formData.middleName = ''
      },
      onBlockPhone () {
        this.isBlockPhone = true
        this.viewInputCode = false
        this.preCheckedPhone = null
      },
      async regReplay () {
        try {
          await api.registration.register.regReplay({ email: this.formData.email })

          this.confirmLinkIsSent = true
          this.confirmLinkKey++ // Restart countdown
        } catch (e) {
          alert('Не удалось отправить ссылку')
        }
      },
      onCountryChange () {
        this.formData.legalNameShort = null

        this.$refs.inn.resetAll()
      },
      inputNewPhone () {
        this.clearPhoneState()
        this.$nextTick(() => {
          this.$refs.phone.focus()
          this.$refs.phone.dirty = false
        })
      },
      resetKppState () {
        this.isKppExist = null
      },
      onCloseCardInfo () {
        this.clearInnState()
        this.$refs.phone.focus()
        this.$refs.phone.dirty = false
      }
    }
  }
</script>
<style lang="scss">
  .registration-form {
    .ob-button-container {
      width: 100%;
    }
  }
</style>
<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";
  @import "~common-components/src/assets/style/ob-style";

  .registration-form {
    &__title {
      @include font-mixin(20px, 24px, 700, $color-text-base, 0.4px);
      margin-bottom: 20px;
    }

    .top-40 {
      margin-top: 40px;
    }

    .bottom-20 {
      margin-bottom: 20px;
    }

    &__text-success {
      @include font-mixin(12px, 14px, 400, $caribbean-green, 0.4px);
      margin-left: 13px;
    }

    &__text-error {
      @include font-mixin(12px, 14px, 400, $light-raspberry-red, 0.4px);
      margin-left: 13px;
      &.--is-row {
        margin-left: 0;
        font-size: 14px;
        line-height: 20px;
      }
    }

    &__block-accept {
      margin-top: 30px;
      &-text {
        @include font-mixin(12px, 16px, 400, $color-grey-span, 0.3px);
      }
      a {
        @include font-mixin(12px, 16px, 400, $color-blue-navy-blue, 0.3px, none, none);
      }
    }

    &__sms-timeout {
      @include font-mixin(12px, 12px, 400, $light-raspberry-red, 0.4px);

      margin: 5px 0 20px;
    }

    &__sms-alert {
      margin-top: 20px;
    }
  }

  .row-block {
    display: flex;
    align-items: center;
    height: 100%;

    .col-block {
      &:first-of-type {
        width: 204px;
      }

      &:last-of-type {
        width: calc(100% - 211px);
        margin-left: 7px;
      }
    }

    &.alternative {
      .col-block {
        &:first-of-type {
          width: 174px;
        }

        &:last-of-type {
          width: calc(100% - 183px);
          margin-left: 9px;
        }
      }
    }
  }

  .text-style {
    @include font-mixin(12px, 18px, 400);
  }

  .text-success {
    @include font-mixin(12px, 14px, 400, $caribbean-green, 0.4px);

    margin-left: 13px;
  }

  .text-error {
    @include font-mixin(12px, 14px, 400, $light-raspberry-red, 0.4px);

    margin-left: 13px;
  }
</style>

<style>
  .registration-tooltip {
    max-width: 220px;
  }
</style>
